Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/physiq.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/physiq.F	(revision 634)
@@ -15,4 +15,13 @@
       USE ioipsl
       USE histcom
+      USE comgeomphy
+      USE write_field
+      USE write_field_p
+      USE dimphy
+      USE iophy
+c$$$      USE misc_mod, mydebug=>debug
+#ifdef CPP_PARALLEL
+      USE vampir
+#endif
 #ifdef INCA
       USE chemshut
@@ -35,11 +44,11 @@
 c   CLEFS CPP POUR LES IO
 c   =====================
-#define histhf
+c#define histhf
 #define histday
 #define histmth
-#define histins
+c#define histins
 c#define histISCCP
-#define histREGDYN
-#define histmthNMC
+c#define histREGDYN
+c#define histmthNMC
 c======================================================================
 c    modif   ( P. Le Van ,  12/10/98 )
@@ -77,5 +86,7 @@
       integer jjmp1
       parameter (jjmp1=jjm+1-1/jjm)
-#include "dimphy.h"
+      integer iip1
+      parameter (iip1=iim+1)
+cym#include "dimphy.h"
 #include "regdim.h"
 #include "indicesol.h"
@@ -85,5 +96,5 @@
 #include "logic.h"
 #include "temps.h"
-#include "comgeomphy.h"
+cym#include "comgeomphy.h"
 #include "advtrac.h"
 #include "iniprint.h"
@@ -161,6 +172,6 @@
       REAL fm_therm(klon,klev+1)
       REAL entr_therm(klon,klev)
-      real q2(klon,klev+1,nbsrf)
-      save q2
+      real,allocatable,save :: q2(:,:,:)
+cym      save q2
 c======================================================================
 c
@@ -194,6 +205,6 @@
       REAL qx(klon,klev,nqmax)
 
-      REAL t_ancien(klon,klev), q_ancien(klon,klev)
-      SAVE t_ancien, q_ancien
+      REAL,allocatable,save :: t_ancien(:,:), q_ancien(:,:)
+cym      SAVE t_ancien, q_ancien
       LOGICAL ancien_ok
       SAVE ancien_ok
@@ -214,27 +225,27 @@
       real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
 
-      INTEGER klevp1, klevm1
-      PARAMETER(klevp1=klev+1,klevm1=klev-1)
-#include "raddim.h"
+cym      INTEGER klevp1, klevm1
+cym      PARAMETER(klevp1=klev+1,klevm1=klev-1)
+cym#include "raddim.h"
 c
 cIM 080304   REAL swdn0(klon,2), swdn(klon,2), swup0(klon,2), swup(klon,2)
-      REAL swdn0(klon,klevp1), swdn(klon,klevp1)
-      REAL swup0(klon,klevp1), swup(klon,klevp1)
-      SAVE swdn0 , swdn, swup0, swup
-c
-      REAL SWdn200clr(klon), SWdn200(klon)
-      REAL SWup200clr(klon), SWup200(klon)
-      SAVE SWdn200clr, SWdn200, SWup200clr, SWup200
-c
-      REAL lwdn0(klon,klevp1), lwdn(klon,klevp1)
-      REAL lwup0(klon,klevp1), lwup(klon,klevp1)
-      SAVE lwdn0 , lwdn, lwup0, lwup 
-c
-      REAL LWdn200clr(klon), LWdn200(klon)
-      REAL LWup200clr(klon), LWup200(klon)
-      SAVE LWdn200clr, LWdn200, LWup200clr, LWup200
-c
-      REAL LWdnTOA(klon), LWdnTOAclr(klon)
-      SAVE LWdnTOA, LWdnTOAclr
+      REAL,allocatable,save :: swdn0(:,:), swdn(:,:)
+      REAL,allocatable,save :: swup0(:,:), swup(:,:)
+cym      SAVE swdn0 , swdn, swup0, swup
+c
+      REAL,allocatable,save :: SWdn200clr(:), SWdn200(:)
+      REAL,allocatable,save :: SWup200clr(:), SWup200(:)
+cym      SAVE SWdn200clr, SWdn200, SWup200clr, SWup200
+c
+      REAL,allocatable,save :: lwdn0(:,:), lwdn(:,:)
+      REAL,allocatable,save :: lwup0(:,:), lwup(:,:)
+cym      SAVE lwdn0 , lwdn, lwup0, lwup 
+c
+      REAL,allocatable,save :: LWdn200clr(:), LWdn200(:)
+      REAL,allocatable,save :: LWup200clr(:), LWup200(:)
+cym      SAVE LWdn200clr, LWdn200, LWup200clr, LWup200
+c
+      REAL,allocatable,save :: LWdnTOA(:), LWdnTOAclr(:)
+cym      SAVE LWdnTOA, LWdnTOAclr
 c
 c vents meridien et zonal a un niveau de pression
@@ -296,6 +307,6 @@
 cv3.4
       INTEGER debug, debugcol
-      INTEGER npoints
-      PARAMETER(npoints=klon) 
+cym      INTEGER npoints
+cym      PARAMETER(npoints=klon) 
 c
       INTEGER sunlit(klon) !sunlit=1 if day; sunlit=0 if night
@@ -457,12 +468,12 @@
       SAVE radpas                 ! frequence d'appel rayonnement
 c
-      REAL radsol(klon)
-      SAVE radsol               ! bilan radiatif au sol calcule par code radiatif
-c
-      REAL rlat(klon)
-      SAVE rlat                   ! latitude pour chaque point
-c
-      REAL rlon(klon)
-      SAVE rlon                   ! longitude pour chaque point
+      REAL,allocatable,save :: radsol(:)
+cym      SAVE radsol               ! bilan radiatif au sol calcule par code radiatif
+c
+      REAL,allocatable,save :: rlat(:)
+cym      SAVE rlat                   ! latitude pour chaque point
+c
+      REAL,allocatable,save :: rlon(:)
+cym      SAVE rlon                   ! longitude pour chaque point
 c
 cc      INTEGER iflag_con
@@ -478,31 +489,31 @@
       real slp(klon) ! sea level pressure
 
-      REAL ftsol(klon,nbsrf)
-      SAVE ftsol                  ! temperature du sol
-c
-      REAL ftsoil(klon,nsoilmx,nbsrf)
-      SAVE ftsoil                 ! temperature dans le sol
-c
-      REAL fevap(klon,nbsrf)
-      SAVE fevap                 ! evaporation
-      REAL fluxlat(klon,nbsrf)
-      SAVE fluxlat
-c
-      REAL deltat(klon)
-      SAVE deltat                 ! ecart avec la SST de reference
-c
-      REAL fqsurf(klon,nbsrf)
-      SAVE fqsurf                 ! humidite de l'air au contact de la surface
-c
-      REAL qsol(klon)
-      SAVE qsol                  ! hauteur d'eau dans le sol
-c
-      REAL fsnow(klon,nbsrf)
-      SAVE fsnow                  ! epaisseur neigeuse
-c
-      REAL falbe(klon,nbsrf)
-      SAVE falbe                  ! albedo par type de surface
-      REAL falblw(klon,nbsrf)
-      SAVE falblw                 ! albedo par type de surface
+      REAL,allocatable,save :: ftsol(:,:)
+cym      SAVE ftsol                  ! temperature du sol
+c
+      REAL,allocatable,save :: ftsoil(:,:,:)
+cym      SAVE ftsoil                 ! temperature dans le sol
+c
+      REAL,allocatable,save :: fevap(:,:)
+cym      SAVE fevap                 ! evaporation
+      REAL,allocatable,save :: fluxlat(:,:)
+cym      SAVE fluxlat
+c
+      REAL,allocatable,save :: deltat(:)
+cym      SAVE deltat                 ! ecart avec la SST de reference
+c
+      REAL,allocatable,save :: fqsurf(:,:)
+cym      SAVE fqsurf                 ! humidite de l'air au contact de la surface
+c
+      REAL,allocatable,save :: qsol(:)
+cym      SAVE qsol                  ! hauteur d'eau dans le sol
+c
+      REAL,allocatable,save :: fsnow(:,:)
+cym      SAVE fsnow                  ! epaisseur neigeuse
+c
+      REAL,allocatable,save :: falbe(:,:)
+cym      SAVE falbe                  ! albedo par type de surface
+      REAL,allocatable,save :: falblw(:,:)
+cym      SAVE falblw                 ! albedo par type de surface
 
 c
@@ -510,57 +521,57 @@
 c  Parametres de l'Orographie a l'Echelle Sous-Maille (OESM):
 c
-      REAL zmea(klon)
-      SAVE zmea                   ! orographie moyenne
-c
-      REAL zstd(klon)
-      SAVE zstd                   ! deviation standard de l'OESM
-c
-      REAL zsig(klon)
-      SAVE zsig                   ! pente de l'OESM
-c
-      REAL zgam(klon)
-      save zgam                   ! anisotropie de l'OESM
-c
-      REAL zthe(klon)
-      SAVE zthe                   ! orientation de l'OESM
-c
-      REAL zpic(klon)
-      SAVE zpic                   ! Maximum de l'OESM
-c
-      REAL zval(klon)
-      SAVE zval                   ! Minimum de l'OESM
-c
-      REAL rugoro(klon)
-      SAVE rugoro                 ! longueur de rugosite de l'OESM
+      REAL,allocatable,save :: zmea(:)
+cym      SAVE zmea                   ! orographie moyenne
+c
+      REAL,allocatable,save :: zstd(:)
+cym      SAVE zstd                   ! deviation standard de l'OESM
+c
+      REAL,allocatable,save :: zsig(:)
+cym      SAVE zsig                   ! pente de l'OESM
+c
+      REAL,allocatable,save :: zgam(:)
+cym      save zgam                   ! anisotropie de l'OESM
+c
+      REAL,allocatable,save :: zthe(:)
+cym      SAVE zthe                   ! orientation de l'OESM
+c
+      REAL,allocatable,save :: zpic(:)
+cym      SAVE zpic                   ! Maximum de l'OESM
+c
+      REAL,allocatable,save :: zval(:)
+cym      SAVE zval                   ! Minimum de l'OESM
+c
+      REAL,allocatable,save :: rugoro(:)
+cym      SAVE rugoro                 ! longueur de rugosite de l'OESM
 c
       REAL zulow(klon),zvlow(klon),zustr(klon), zvstr(klon)
 c
-      REAL zuthe(klon),zvthe(klon)
-      SAVE zuthe
-      SAVE zvthe
+      REAL,allocatable,save :: zuthe(:),zvthe(:)
+cym      SAVE zuthe
+cym      SAVE zvthe
       INTEGER igwd,idx(klon),itest(klon)
 c
-      REAL agesno(klon,nbsrf)
-      SAVE agesno                 ! age de la neige
-c
-      REAL alb_neig(klon)
-      SAVE alb_neig               ! albedo de la neige
-c
-      REAL run_off_lic_0(klon)
-      SAVE run_off_lic_0
+      REAL,allocatable,save :: agesno(:,:)
+cym      SAVE agesno                 ! age de la neige
+c
+      REAL,allocatable,save :: alb_neig(:)
+cym      SAVE alb_neig               ! albedo de la neige
+c
+      REAL,allocatable,save :: run_off_lic_0(:)
+cym      SAVE run_off_lic_0
 cKE43
 c Variables liees a la convection de K. Emanuel (sb):
 c
-      REAL ema_workcbmf(klon)   ! cloud base mass flux
-      SAVE ema_workcbmf
-
-      REAL ema_cbmf(klon)       ! cloud base mass flux
-      SAVE ema_cbmf
-
-      REAL ema_pcb(klon)        ! cloud base pressure
-      SAVE ema_pcb
-
-      REAL ema_pct(klon)        ! cloud top pressure
-      SAVE ema_pct
+      REAL,allocatable,save :: ema_workcbmf(:)   ! cloud base mass flux
+cym      SAVE ema_workcbmf
+
+      REAL,allocatable,save :: ema_cbmf(:)       ! cloud base mass flux
+cym      SAVE ema_cbmf
+
+      REAL,allocatable,save :: ema_pcb(:)        ! cloud base pressure
+cym      SAVE ema_pcb
+
+      REAL,allocatable,save :: ema_pct(:)        ! cloud top pressure
+cym      SAVE ema_pct
 
       REAL bas, top             ! cloud base and top levels
@@ -568,14 +579,14 @@
       SAVE top
 
-      REAL Ma(klon,klev)        ! undilute upward mass flux
-      SAVE Ma
-      REAL qcondc(klon,klev)    ! in-cld water content from convect
-      SAVE qcondc 
-      REAL ema_work1(klon, klev), ema_work2(klon, klev)
-      SAVE ema_work1, ema_work2
+      REAL,allocatable,save :: Ma(:,:)        ! undilute upward mass flux
+cym      SAVE Ma
+      REAL,allocatable,save :: qcondc(:,:)    ! in-cld water content from convect
+cym      SAVE qcondc 
+      REAL,allocatable,save :: ema_work1(:, :), ema_work2(:, :)
+cym      SAVE ema_work1, ema_work2
       REAL wdn(klon), tdn(klon), qdn(klon)
 
-      REAL wd(klon) ! sb
-      SAVE wd       ! sb
+      REAL,allocatable,save :: wd(:) ! sb
+cym      SAVE wd       ! sb
 
 c Variables locales pour la couche limite (al1):
@@ -604,10 +615,10 @@
 c$$$      PARAMETER (offline=.false.)
 c$$$      INTEGER physid
-      REAL pfrac_impa(klon,klev)! Produits des coefs lessivage impaction
-      save pfrac_impa
-      REAL pfrac_nucl(klon,klev)! Produits des coefs lessivage nucleation
-      save pfrac_nucl
-      REAL pfrac_1nucl(klon,klev)! Produits des coefs lessi nucl (alpha = 1)
-      save pfrac_1nucl
+      REAL,allocatable,save :: pfrac_impa(:,:)! Produits des coefs lessivage impaction
+cym      save pfrac_impa
+      REAL,allocatable,save :: pfrac_nucl(:,:)! Produits des coefs lessivage nucleation
+cym      save pfrac_nucl
+      REAL,allocatable,save :: pfrac_1nucl(:,:)! Produits des coefs lessi nucl (alpha = 1)
+cym      save pfrac_1nucl
       REAL frac_impa(klon,klev) ! fractions d'aerosols lessivees (impaction)
       REAL frac_nucl(klon,klev) ! idem (nucleation)
@@ -618,22 +629,22 @@
 
 cAA
-      REAL rain_fall(klon) ! pluie
-      REAL snow_fall(klon) ! neige
-      save snow_fall, rain_fall
+      REAL,allocatable,save :: rain_fall(:) ! pluie
+      REAL,allocatable,save :: snow_fall(:) ! neige
+cym      save snow_fall, rain_fall
 cIM 050204 BEG
-      REAL total_rain(klon), nday_rain(klon)
-      save total_rain, nday_rain
+      REAL,allocatable,save :: total_rain(:), nday_rain(:)
+cym      save total_rain, nday_rain
 cIM 050204 END
       REAL evap(klon), devap(klon) ! evaporation et sa derivee
       REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
-      REAL dlw(klon)    ! derivee infra rouge
+      REAL,allocatable,save :: dlw(:)    ! derivee infra rouge
 cym
-      SAVE dlw
+cym      SAVE dlw
 cym
       REAL bils(klon) ! bilan de chaleur au sol
       REAL wfbils(klon,nbsrf) ! bilan de chaleur au sol, pour chaque
 C                             ! type de sous-surface et pondere par la fraction
-      REAL fder(klon) ! Derive de flux (sensible et latente) 
-      save fder
+      REAL,allocatable,save :: fder(:) ! Derive de flux (sensible et latente) 
+cym      save fder
       REAL ve(klon) ! integr. verticale du transport meri. de l'energie
       REAL vq(klon) ! integr. verticale du transport meri. de l'eau
@@ -641,27 +652,30 @@
       REAL uq(klon) ! integr. verticale du transport zonal de l'eau
 c
-      REAL frugs(klon,nbsrf) ! longueur de rugosite
-      save frugs
+      REAL,allocatable,save :: frugs(:,:) ! longueur de rugosite
+cym      save frugs
       REAL zxrugs(klon) ! longueur de rugosite
 c
 c Conditions aux limites
 c
+      INTEGER :: iii
       INTEGER julien
 c
       INTEGER lmt_pas
       SAVE lmt_pas                ! frequence de mise a jour
-      REAL pctsrf(klon,nbsrf)
+      REAL,allocatable,save :: pctsrf(:,:)
 cIM
       REAL pctsrf_new(klon,nbsrf) !pourcentage surfaces issus d'ORCHIDEE
-      REAL paire_ter(klon)        !surfaces terre 
+cym      REAL paire_ter(klon)        !surfaces terre 
+      REAL,allocatable,save ::  paire_ter(:)        !surfaces terre 
+    
 cIM
-      SAVE pctsrf                 ! sous-fraction du sol
-      REAL albsol(klon)
-      SAVE albsol                 ! albedo du sol total
-      REAL albsollw(klon)
-      SAVE albsollw                 ! albedo du sol total
-
-      REAL wo(klon,klev)
-      SAVE wo                     ! ozone
+cym      SAVE pctsrf                 ! sous-fraction du sol
+      REAL,allocatable,save :: albsol(:)
+cym      SAVE albsol                 ! albedo du sol total
+      REAL,allocatable,save :: albsollw(:)
+cym      SAVE albsollw                 ! albedo du sol total
+
+      REAL,allocatable,save :: wo(:,:)
+cym     SAVE wo                     ! ozone
 c======================================================================
 c
@@ -702,7 +716,7 @@
 c Variables locales
 c
-      real clwcon(klon,klev),rnebcon(klon,klev)
+      real,allocatable,save :: clwcon(:,:),rnebcon(:,:)
       real clwcon0(klon,klev),rnebcon0(klon,klev)
-      save rnebcon, clwcon
+cym      save rnebcon, clwcon
 
       REAL rhcl(klon,klev)    ! humiditi relative ciel clair
@@ -725,24 +739,24 @@
       REAL zxfluxv(klon, klev)
 CXXX
-      REAL heat(klon,klev)    ! chauffage solaire
-      REAL heat0(klon,klev)   ! chauffage solaire ciel clair
-      REAL cool(klon,klev)    ! refroidissement infrarouge
-      REAL cool0(klon,klev)   ! refroidissement infrarouge ciel clair
-      REAL topsw(klon), toplw(klon), solsw(klon), sollw(klon)
-      real sollwdown(klon)    ! downward LW flux at surface
+      REAL,allocatable,save :: heat(:,:)    ! chauffage solaire
+      REAL,allocatable,save :: heat0(:,:)   ! chauffage solaire ciel clair
+      REAL,allocatable,save :: cool(:,:)    ! refroidissement infrarouge
+      REAL,allocatable,save :: cool0(:,:)   ! refroidissement infrarouge ciel clair
+      REAL,allocatable,save :: topsw(:), toplw(:), solsw(:), sollw(:)
+      real,allocatable,save :: sollwdown(:)    ! downward LW flux at surface
 cIM BEG
-      real sollwdownclr(klon)    ! downward CS LW flux at surface 
-      real toplwdown(klon)       ! downward CS LW flux at TOA
-      real toplwdownclr(klon)    ! downward CS LW flux at TOA
+      real,allocatable,save :: sollwdownclr(:)    ! downward CS LW flux at surface 
+      real,allocatable,save :: toplwdown(:)       ! downward CS LW flux at TOA
+      real,allocatable,save :: toplwdownclr(:)    ! downward CS LW flux at TOA
 cIM END
-      REAL topsw0(klon), toplw0(klon), solsw0(klon), sollw0(klon)
-      REAL albpla(klon)
+      REAL,allocatable,save :: topsw0(:),toplw0(:),solsw0(:),sollw0(:)
+      REAL,allocatable,save :: albpla(:)
       REAL fsollw(klon, nbsrf)   ! bilan flux IR pour chaque sous surface
       REAL fsolsw(klon, nbsrf)   ! flux solaire absorb. pour chaque sous surface
 c Le rayonnement n'est pas calcule tous les pas, il faut donc
 c                      sauvegarder les sorties du rayonnement
-      SAVE  heat,cool,albpla,topsw,toplw,solsw,sollw,sollwdown
-      SAVE  sollwdownclr, toplwdown, toplwdownclr
-      SAVE  topsw0,toplw0,solsw0,sollw0, heat0, cool0
+cym      SAVE  heat,cool,albpla,topsw,toplw,solsw,sollw,sollwdown
+cym      SAVE  sollwdownclr, toplwdown, toplwdownclr
+cym      SAVE  topsw0,toplw0,solsw0,sollw0, heat0, cool0
 c
       INTEGER itaprad
@@ -785,12 +799,12 @@
       REAL dnwd0(klon,klev)     ! unsaturated downdraft mass flux
       REAL tvp(klon,klev)       ! virtual temp of lifted parcel
-      REAL cape(klon)           ! CAPE
-      SAVE cape
+      REAL,allocatable,save :: cape(:)           ! CAPE
+cym      SAVE cape
       CHARACTER*40 capemaxcels  !max(CAPE)
 
-      REAL pbase(klon)          ! cloud base pressure
-      SAVE pbase
-      REAL bbase(klon)          ! cloud base buoyancy
-      SAVE bbase
+      REAL,allocatable,save :: pbase(:)          ! cloud base pressure
+cym      SAVE pbase
+      REAL,allocatable,save :: bbase(:)          ! cloud base buoyancy
+cym      SAVE bbase
       REAL rflag(klon)          ! flag fonctionnement de convect
       INTEGER iflagctrl(klon)          ! flag fonctionnement de convect
@@ -829,7 +843,7 @@
       REAL prfl(klon,klev+1), psfl(klon,klev+1)
 c
-      INTEGER ibas_con(klon), itop_con(klon)
+      INTEGER,allocatable,save :: ibas_con(:), itop_con(:)
 cym
-      SAVE ibas_con,itop_con
+cym      SAVE ibas_con,itop_con
 cym
       REAL rain_con(klon), rain_lsc(klon)
@@ -846,7 +860,9 @@
       REAL d_u_oli(klon,klev), d_v_oli(klon,klev) !tendances dues a oro et lif 
 
-      REAL ratqs(klon,klev),ratqss(klon,klev),ratqsc(klon,klev)
+      REAL,allocatable,save :: ratqs(:,:)
+      REAL ratqss(klon,klev),ratqsc(klon,klev)
       real ratqsbas,ratqshaut
-      save ratqsbas,ratqshaut, ratqs
+cym      save ratqsbas,ratqshaut, ratqs
+      save ratqsbas,ratqshaut
       real zpt_conv(klon,klev)
 
@@ -956,6 +972,6 @@
 cjq   Aerosol effects (Johannes Quaas, 27/11/2003)
       REAL sulfate(klon, klev) ! SO4 aerosol concentration [ug/m3]
-      REAL sulfate_pi(klon, klev) ! SO4 aerosol concentration [ug/m3] (pre-industrial value)
-      SAVE sulfate_pi
+      REAL,allocatable,save :: sulfate_pi(:,:) ! SO4 aerosol concentration [ug/m3] (pre-industrial value)
+cym      SAVE sulfate_pi
 
       REAL cldtaupi(klon,klev)  ! Cloud optical thickness for pre-industrial (pi) aerosols
@@ -990,7 +1006,101 @@
 c Declaration des constantes et des fonctions thermodynamiques
 c
+      LOGICAL :: first=.true.
 #include "YOMCST.h"
 #include "YOETHF.h"
 #include "FCTTRE.h"
+
+      REAL Field_tmp(klon2,klevp1)
+      
+      if (first) then 
+      
+      allocate( t_ancien(klon,klev), q_ancien(klon,klev))
+      allocate( q2(klon,klev+1,nbsrf))
+      allocate( swdn0(klon,klevp1), swdn(klon,klevp1))
+      allocate( swup0(klon,klevp1), swup(klon,klevp1))
+      allocate( SWdn200clr(klon), SWdn200(klon))
+      allocate( SWup200clr(klon), SWup200(klon))
+      allocate( lwdn0(klon,klevp1), lwdn(klon,klevp1))
+      allocate( lwup0(klon,klevp1), lwup(klon,klevp1))
+      allocate( LWdn200clr(klon), LWdn200(klon))
+      allocate( LWup200clr(klon), LWup200(klon))
+      allocate( LWdnTOA(klon), LWdnTOAclr(klon))
+      allocate( radsol(klon))
+      allocate( rlat(klon))
+      allocate( rlon(klon))
+      allocate( ftsol(klon,nbsrf))
+      allocate( ftsoil(klon,nsoilmx,nbsrf))
+      allocate( fevap(klon,nbsrf))
+      allocate( fluxlat(klon,nbsrf))
+      allocate( deltat(klon))
+      allocate( fqsurf(klon,nbsrf))
+      allocate( qsol(klon))
+      allocate( fsnow(klon,nbsrf))
+      allocate( falbe(klon,nbsrf))
+      allocate( falblw(klon,nbsrf))
+      allocate( zmea(klon))
+      allocate( zstd(klon))
+      allocate( zsig(klon))
+      allocate( zgam(klon))
+      allocate( zthe(klon))
+      allocate( zpic(klon))
+      allocate( zval(klon))
+      allocate( rugoro(klon))
+      allocate( zuthe(klon),zvthe(klon))
+      allocate( agesno(klon,nbsrf))
+      allocate( alb_neig(klon))
+      allocate( run_off_lic_0(klon))
+      allocate( ema_workcbmf(klon))   
+      allocate( ema_cbmf(klon)) 
+      allocate( ema_pcb(klon))
+      allocate( ema_pct(klon))  
+      allocate( Ma(klon,klev) )
+      allocate( qcondc(klon,klev))  
+      allocate( ema_work1(klon, klev), ema_work2(klon, klev))
+      allocate( wd(klon) )
+      allocate( pfrac_impa(klon,klev))
+      allocate( pfrac_nucl(klon,klev))
+      allocate( pfrac_1nucl(klon,klev))
+      allocate( rain_fall(klon) )
+      allocate( snow_fall(klon) )
+      allocate( total_rain(klon), nday_rain(klon))
+      allocate( dlw(klon)   )
+      allocate( fder(klon) )
+      allocate( frugs(klon,nbsrf) )
+      allocate( pctsrf(klon,nbsrf))
+      allocate( albsol(klon))
+      allocate( albsollw(klon))
+      allocate( wo(klon,klev))
+      allocate( clwcon(klon,klev),rnebcon(klon,klev))
+      allocate( heat(klon,klev)    )
+      allocate( heat0(klon,klev)  )
+      allocate( cool(klon,klev)    )
+      allocate( cool0(klon,klev)   )
+      allocate( topsw(klon), toplw(klon), solsw(klon), sollw(klon))
+      allocate( sollwdown(klon)    )
+      allocate( sollwdownclr(klon)  ) 
+      allocate( toplwdown(klon)      )
+      allocate( toplwdownclr(klon)   )
+      allocate( topsw0(klon), toplw0(klon), solsw0(klon), sollw0(klon))
+      allocate( albpla(klon))
+      allocate( cape(klon)   )        
+      allocate( pbase(klon)   )     
+      allocate( bbase(klon)    )     
+      allocate( ibas_con(klon), itop_con(klon))
+      allocate( ratqs(klon,klev))
+      allocate( sulfate_pi(klon, klev)) 
+      allocate( paire_ter(klon))
+      
+        paire_ter(:)=0.    
+        clwcon(:,:)=0.
+	rnebcon(:,:)=0.
+	ratqs(:,:)=0.
+	run_off_lic_0(:)=0.
+	sollw(:)=0.
+	ema_work1(:,:)=0.
+	ema_work2(:,:)=0.
+	
+	first=.false.
+      endif 
 c======================================================================
 !rv
@@ -1164,5 +1274,5 @@
           DO i = 1, klon
            ibas_con(i) = 1
-           itop_con(i) = 1
+           itop_con(i) = klev+1
           ENDDO
 cIM15/11/02 rajout initialisation ibas_con,itop_con cf. SB =>END
@@ -1292,4 +1402,6 @@
 c
 #ifdef INCA
+           call VTe(VTphysiq)
+	   call VTb(VTinca)
            iii = MOD(NINT(xjour),360)
            calday = FLOAT(iii) + gmtime
@@ -1314,4 +1426,6 @@
            WRITE(lunout,*) 'OK.'
 #endif
+      call VTe(VTinca)
+      call VTb(VTphysiq)
 #endif
 c
@@ -1538,5 +1652,11 @@
       fder = dlw
 
-
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
+  
       CALL clmain(dtime,itap,date0,pctsrf,pctsrf_new,
      e            t_seri,q_seri,u_seri,v_seri,
@@ -1596,4 +1716,12 @@
       ENDDO
       ENDDO
+
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
+
 c
       IF (if_ebil.ge.2) THEN 
@@ -1833,4 +1961,11 @@
         ENDDO
       ENDDO
+
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
 c
       IF (if_ebil.ge.2) THEN 
@@ -2033,4 +2168,12 @@
      s      , fs_bound, fq_bound )
       END IF 
+
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
+
 c
 c-------------------------------------------------------------------
@@ -2252,5 +2395,7 @@
      &     boxptop)
 
-
+      
+      if (monocpu) then
+      
 c passage de la grille (klon,7,7) a (iim,jjmp1,7,7)
       DO l=1, lmaxm1
@@ -2301,4 +2446,6 @@
        ENDDO
       ENDDO
+      
+      endif ! monocpu
 c
       ENDIF !ok_isccp
@@ -2380,4 +2527,6 @@
 
 #ifdef INCA
+      call VTe(VTphysiq)
+      call VTb(VTinca)
            calday = FLOAT(julien) + gmtime
 
@@ -2433,4 +2582,6 @@
            WRITE(lunout,*)'OK.'
 #endif
+      call VTe(VTinca)
+      call VTb(VTphysiq)
 #endif
 c     
@@ -2471,4 +2622,12 @@
      .               + falblw(i,is_sic) * pctsrf(i,is_sic)
       ENDDO
+
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
+      
       CALL radlwsw ! nouveau rayonnement (compatible Arpege-IFS)
      e            (dist, rmu0, fract, 
@@ -2500,4 +2659,11 @@
       ENDDO
 c
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
+      
       IF (if_ebil.ge.2) THEN 
         ztit='after rad'
@@ -2585,4 +2751,11 @@
       ENDIF ! fin de test sur ok_orodr
 c
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
+      
       IF (ok_orolf) THEN
 c
@@ -2617,4 +2790,12 @@
       ENDIF ! fin de test sur ok_orolf
 c
+
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
+
       IF (if_ebil.ge.2) THEN 
         ztit='after orography'
@@ -2852,4 +3033,11 @@
 c Convertir les incrementations en tendances
 c
+c$$$      if (mydebug) then
+c$$$        call WriteField_phy_p('u_seri',u_seri,llm)
+c$$$        call WriteField_phy_p('v_seri',v_seri,llm)
+c$$$        call WriteField_phy_p('t_seri',t_seri,llm)
+c$$$	call WriteField_phy_p('q_seri',q_seri,llm)
+c$$$      endif
+
       DO k = 1, klev
       DO i = 1, klon
@@ -2918,4 +3106,6 @@
 
 #ifdef INCA
+      call VTe(VTphysiq)
+      call VTb(VTinca)
 #ifdef INCAINFO
            WRITE(lunout,*)'Appel CHEMHOOK_END ...'
@@ -2945,4 +3135,6 @@
            WRITE(lunout,*)'OK.'
 #endif
+      call VTe(VTinca)
+      call VTb(VTphysiq)
 #endif
 
